import {
  scaleLinear,
  scaleOrdinal,
  extent,
  axisLeft,
  axisBottom,
  symbols,
  symbol,
} from 'd3';
export const scatterPlot = () => {
  let width;
  let height;
  let data;
  let xValue;
  let yValue;
  let symbolValue;
  let margin;
  let size;

  const my = (selection) => {
    //console.log(data);
    // scaleLinear does a mapping from data to screen

    //         const x = scaleLinear().domain([
    //           d3.min(data, xValue),
    //           d3.max(data, xValue),]
    //           // d3.min(+data.petal_length),
    //           // d3.max(+data.sepal_length),

    //         );
    const x = scaleLinear()
      .domain(extent(data, xValue))
      //.range([0, width]);
      .range([margin.left, width - margin.right]);
    const y = scaleLinear()
      .domain(extent(data, yValue))
      //.range([height, 0]);
      .range([
        height - margin.bottom,
        margin.top,
      ]);
    const symbolGenerator = symbol().size(size);
    const symbolScale = scaleOrdinal()
      .domain(data.map(symbolValue)) // map to automatically de duplicate
      .range(symbols);
    console.log(symbolScale.domain());

    const marks = data.map((d) => ({
      x: x(xValue(d)),
      y: y(yValue(d)),
      pathD: symbolGenerator.type(
        symbolScale(symbolValue(d))
      )(),
      p_x: xValue(d),
      p_y: yValue(d),
    }));
    //console.log(marks);

    selection
      .selectAll('path')
      .data(marks)
      .join('path')
      .attr('d', (d) => d.pathD)
      .attr(
        'transform',
        (d) => `translate(${d.x},${d.y})`
      )

      .append('title')
      .text((d) => `(${d.p_x},${d.p_y})`);
    selection
      .append('g')
      .attr(
        'transform',
        `translate(${margin.left},0)`
      )
      .call(axisLeft(y));
    selection
      .append('g')
      .attr(
        'transform',
        `translate(0, ${height - margin.bottom})`
      )
      .call(axisBottom(x));
  };

  my.width = function (_) {
    return arguments.length
      ? ((width = +_), my) //return my
      : width;
  };
  my.height = function (_) {
    return arguments.length
      ? ((height = +_), my) //return my
      : height;
  };

  my.data = function (_) {
    return arguments.length
      ? ((data = _), my) //return my
      : data;
  };
  my.xValue = function (_) {
    return arguments.length
      ? ((xValue = _), my) //return my
      : xValue;
  };
  my.yValue = function (_) {
    return arguments.length
      ? ((yValue = _), my) //return my
      : yValue;
  };
  my.symbolValue = function (_) {
    return arguments.length
      ? ((symbolValue = _), my) //return my
      : symbolValue;
  };
  my.margin = function (_) {
    return arguments.length
      ? ((margin = _), my) //return my
      : margin;
  };
  my.size = function (_) {
    return arguments.length
      ? ((size = +_), my) //return my  "+" to make sure it is a number type
      : size;
  };
  return my;
};
